%% This is file `DEMO-TUDaBeamer.tex' version 2.09 (2020/03/13),
%% it is part of
%% TUDa-CI -- Corporate Design for TU Darmstadt
%% ----------------------------------------------------------------------------
%%
%%  Copyright (C) 2018--2020 by Marei Peischl <marei@peitex.de>
%%
%% ============================================================================
%% This work may be distributed and/or modified under the
%% conditions of the LaTeX Project Public License, either version 1.3c
%% of this license or (at your option) any later version.
%% The latest version of this license is in
%% http://www.latex-project.org/lppl.txt
%% and version 1.3c or later is part of all distributions of LaTeX
%% version 2008/05/04 or later.
%%
%% This work has the LPPL maintenance status `maintained'.
%%
%% The Current Maintainers of this work are
%%   Marei Peischl <tuda-ci@peitex.de>
%%   Markus Lazanowski <latex@ce.tu-darmstadt.de>
%%
%% The development respository can be found at
%% https://github.com/tudace/tuda_latex_templates
%% Please use the issue tracker for feedback!
%%
%% ============================================================================
%%
% !TeX program = lualatex
%%

\documentclass[
	ngerman,%globale Übergabe der Hauptsprache
	aspectratio=169,%Beamer eigene Option zum Umschalten des Formates
	color={accentcolor=2d},
	logo=false,%Kein Logo auf Folgeseiten
	colorframetitle=false,%Akzentfarbe auch im Frametitle
%	logofile=example-image, %Falls die Logo Dateien nicht vorliegen
	]{tudabeamer}
\usepackage[main=ngerman]{babel}
\usepackage{booktabs}
\usepackage{listings}
\usepackage{pgfgantt}
\usepackage{rotating}

% Der folgende Block ist nur bei pdfTeX auf Versionen vor April 2018 notwendig
\usepackage{iftex}
\ifPDFTeX
\usepackage[utf8]{inputenc}%kompatibilität mit TeX Versionen vor April 2018
\fi

 %Let's define some awesome new ganttchart elements:
\newganttchartelement{orangebar}{
    orangebar/.style={
        inner sep=0pt,
        draw=red!66!black,
        very thick,
        top color=white,
        bottom color=orange!80
    },
    orangebar label font=\slshape,
    orangebar left shift=.1,
    orangebar right shift=-.1
}

\newganttchartelement{bluebar}{
    bluebar/.style={
        inner sep=0pt,
        draw=purple!44!black,
        very thick,
        top color=white,
        bottom color=blue!80
    },
    bluebar label font=\slshape,
    bluebar left shift=.1,
    bluebar right shift=-.1
}

\newganttchartelement{greenbar}{
    greenbar/.style={
        inner sep=0pt,
        draw=green!50!black,
        very thick,
        top color=white,
        bottom color=green!80
    },
    greenbar label font=\slshape,
    greenbar left shift=.1,
    greenbar right shift=-.1
}

\newganttchartelement{graybar}{
    graybar/.style={
        inner sep=0pt,
        draw=gray!50!black,
        very thick,
        top color=white,
        bottom color=gray!80
    },
   graybar label font=\slshape,
   graybar left shift=.1,
   graybar right shift=-.1
}

\newganttchartelement{yellowbar}{
    yellowbar/.style={
        inner sep=0pt,
        draw=white,
        thick,
        top color=white,
        bottom color=white
    },
   yellowbar label font=\slshape,
   yellowbar left shift=.1,
   yellowbar right shift=-.1
}


\input{../solidity-highlighting}


%Makros für Formatierungen der Doku
%Im Allgemeinen nicht notwendig!
\let\code\texttt
\title{Blockchain Praktikum 2020
by Prof. Dr. Sebastian Faust}
\subtitle{ Integrating IoT in a Decentralized Renting Application}
\author[Alexander Lieb, Lennard Rüdesheim]{Alexander Lieb, Lennard Rüdesheim}
\department{FB 20}
\institute{Angewandte Kryptographie}

%Fremdlogo
%Logo Macro mit Sternchen skaliert automatisch, sodass das Logo in die Fußzeile passt
\logo*{\includegraphics{CAC-Logo-RGB_182_1}}

% Da das Bild frei wählbar nach Breite und/oder Höhe skaliert werden kann, werden \width/\height entsprechend gesetzt. So kann die Fläche optimal gefüllt werden.
%Sternchenversion skaliert automatisch und beschneidet das Bild, um die Fläche zu füllen.
%\titlegraphic*{\includegraphics{example-image}}
\date{\today}

\begin{document}

\maketitle

\setupTUDaFrame{logo=true}
\begin{frame}{Recap: Integrating IoT in a Decentralized
Renting Application}

  \begin{figure}
    \centering
    \includegraphics[scale=.45]{img/recap.jpg}
  \end{figure}
    
\end{frame}


\begin{frame} {Recap: Working Renting System}

    \begin{figure}
    \centering
    \includegraphics[scale=.45]{img/contracts.jpg}
  \end{figure}

\end{frame}

\begin{frame} {Recap: User Interface}

  \begin{columns}
    \begin{column} {0.5\textwidth}
      \begin{figure}
        \centering
        \includegraphics[scale=.45]{../img/Screenshot_Master_UI.pdf}
      \end{figure}  
    \end{column}
    \begin{column} {0.5\textwidth}
      \begin{figure}
        \centering
        \includegraphics[scale=.24]{../img/Screenshot_City_UI.pdf}
      \end{figure}  
    \end{column}
  \end{columns}
\end{frame}

%\begin{frame}{Progress (1)}
%
%  \begin{table}[!h]
%    \begin{tabular}{p{4cm}p{5cm}p{5cm}}
%      \toprule
%      \textbf{Milestones} & \textbf{Open User Stories}  &  \textbf{ Finished User Stories }\\
%      \midrule
%      \textbf{Working \linebreak Renting System} \newline (finished)& - & US1: User can add a bike (Sprint 1)   \\  
%      &  & \\
%      & &US2: User is able to rent a bike (Sprint 1) \\
%      &  & \\
%      & & US3: User is able to release a bike (Sprint 1)\\
%      \bottomrule
      
%    \end{tabular}
%\end{table}
%\end{frame}


\begin{frame} {Progress (1)}
  \begin{table}
    \begin{tabular}{p{4cm}p{5cm}p{5cm}}

      \toprule
      \textbf{Milestones} & \textbf{Open User Stories}  &  \textbf{ Finished User Stories }\\
      \midrule
  \textbf{IoT device is working}  \newline (finished) & -  & US6: User can get GPS data from RPI (Sprint 2)\\
    & & \\  
    &  &US4: RPI can access the LTE Stick (Sprint 3)\\
    & & \\  
    & &US5: The RPI can lock the bike (Sprint 4)\\
      \bottomrule
    \end{tabular}
\end{table}
\end{frame}


\begin{frame} {Progress (2)}
  \begin{table}
    \begin{tabular}{p{4cm}p{5cm}p{5cm}}

      \toprule
      \textbf{Milestones} & \textbf{Open User Stories}  &  \textbf{ Finished User Stories }\\
      \midrule
 \textbf{IoT device is connected to the  contract} \newline (finished)  &  &  US8: Bike posts the distance it has traveled (Sprint 3)  \\
         & &US7: Smart Contract locks the bike when it is released (Sprint 4)  \\
         && \\
    & &US9: User is able to unlock the bike through the Smart Contract (Sprint 4)\\
      \bottomrule
    \end{tabular}
\end{table}
\end{frame}

\begin{frame} {Connection between IoT device and city contract}

    \begin{figure}
    \centering
    \includegraphics[scale=.4]{img/IoT_contract_connection_protocol.pdf}
  \end{figure}

\end{frame}

\begin{frame} {Connection between IoT device and city contract - \\ Rent Bike}

    \begin{figure}
    \centering
    \includegraphics[scale=.37]{img/rent_bike_protocol.pdf}
  \end{figure}

\end{frame}

\begin{frame} {Connection between IoT device and city contract - \\ Return Bike}

    \begin{figure}
    \centering
    \includegraphics[scale=.4]{img/return_bike_protocol.pdf}
  \end{figure}

\end{frame}



\begin{frame} {Bike Lock (1)}
\center
        \includegraphics[scale=.05]{../../Lock_Img/IMG_9730.JPG}


\end{frame}

\begin{frame} {Bike Lock  (2)}
\center

        \includegraphics[scale=.045]{../../Lock_Img/IMG_9720.JPG}

\end{frame}


\begin{frame} {Backup: User Interface}

  \begin{columns}
    \begin{column} {0.5\textwidth}
      \begin{figure}
        \centering
        \includegraphics[scale=.45]{img/Screenshot_Master_UI.png}
      \end{figure}  
    \end{column}
  \end{columns}
\end{frame}



\begin{frame} {Backup: User Interface}

  \begin{columns}
    \begin{column} {0.5\textwidth}
      \begin{figure}
        \centering
        \includegraphics[scale=.38]{img/Screenshot_City_UI_Bikes.png}
      \end{figure}  
    \end{column}
    \begin{column} {0.5\textwidth}
      \begin{figure}
        \centering
        \includegraphics[scale=.29]{img/Screenshot_City_UI_Forms.png}
      \end{figure}  
    \end{column}
  \end{columns}
\end{frame}



\begin{frame} {Backup: User Interface}

  \begin{columns}
    \begin{column} {0.5\textwidth}
      \begin{figure}
        \centering
        \includegraphics[scale=.25]{img/Screenshot_Map.png}
      \end{figure}  
    \end{column}
  \end{columns}
\end{frame}







%\begin{frame}[fragile] {Master Contract}
%  \begin{columns}[T]
%    \begin{column}{0.05\textwidth}
%      ~
%    \end{column}
%    \begin{column}{0.9\textwidth}
%      \begin{lstlisting} [language=Solidity]
%        contract Master {
%          struct city { 
%            string country; 
%            string state; 
%            string city; 
%            address place; 
%          } 
%          [...] // events 
%          city[] public registeredCities; 
%          function getCity(uint which) external view returns (string memory) [...] 
%          function getPlace(uint which) external view returns (address) [...] 
%          function register(string calldata _country, string calldata _state, string calldata _city, address _place) external [...] 
%        } 
%      \end{lstlisting}
%    \end{column}
%  \end{columns}
%\end{frame}

%\begin{frame} {Master Contract}
 % \begin{itemize}
  %\item Meeting Point
 % \item address is hardcoded in the DAPP
 %\item All City Contracts are registered here
%  \item Stores each city as struct, consisting of
%    \begin{itemize}
%    \item Country
%    \item State
%    \item Name of City
%    \item Address of City Contract
%    \end{itemize}
%  \item Has a function to return the address of a requested city
%  \end{itemize}
%\end{frame}

%\begin{frame} {City Contract (1)}
 % \begin{itemize}
 % \item Registers at Master Contract on construction
 % \item Represents a City, participating in the Rent-A-Bike system
 % \item Has a mapping, storing all bikes
%  \item A bike has the following attributes
  %  \begin{itemize}
 %   \item Owner
  %  \item hirer refund
 %   \item base price
  %  \item price per km (to be implemented)
  %  \item actual hirer (if no hirer, bike is available)
 %   \end{itemize}
 % \end{itemize}
%\end{frame}

%\begin{frame} {City Contract (2)}

%  \begin{itemize}
%  \item Has a mapping, storing the actual balance of an owner
%    \begin{itemize}
%      \item The owner must send an tx to the contract to get his money
%    \end{itemize}
%  \item Functionality:
%    \begin{itemize}
%    \item Add Bike
%    \item Remove Bike
%    \item Rent Bike
%    \item Return Bike
%    \end{itemize}
%  \end{itemize}
%\end{frame}


%\begin{frame}[fragile] {City Contract (1)}
%  \begin{columns}[T]
%    \begin{column}{0.05\textwidth}
%      ~
%    \end{column}
%    \begin{column}{0.9\textwidth}
%      \begin{lstlisting} [language=Solidity]
%        contract Renting{
%          struct Bike{
%            address owner;
%            uint hirer_refund;
%            uint base_price;
%            // 0 indicates that this bike is not hired yet
%            address hirer;
%            uint amount_hirer_paid;
%          }
%          mapping(uint => Bike) public bikes;
%          mapping(address => uint) public refunds;
%          uint public bikeCount;
%          uint public constant owner_refund = 42;
%          [...] // events
%      \end{lstlisting}
%    \end{column}
%  \end{columns}
%\end{frame}

%\begin{frame}[fragile] {City Contract (2)}
%  \begin{columns}[T]
%    \begin{column}{0.05\textwidth}
%      ~
%    \end{column}
%    \begin{column}{0.9\textwidth}
%      \begin{lstlisting} [language=Solidity]
%        constructor(string memory _country, string memory _state, string memory _city, address _master_address) public [...]
%
%        function addBike(uint _base_price, /*uint _cpkm,*/ uint _hirer_refund) external payable [...]
%
%        function rentBike(uint _bikeId) external payable [...]
%
%        function returnBike(uint _bikeId) external [...]
%
%        function removeBike(uint _bikeId) external [...]
%
%        function refund() external [...]
%      }
%
%      \end{lstlisting}
%    \end{column}
%  \end{columns}
%\end{frame}



%\begin{frame} {IoT Device is working}
 % \begin{figure}
  %  \centering
   % \includegraphics[scale=.048]{img/img.jpg}
 % \end{figure}
    
%\end{frame}

%\begin{frame} {GPS Wrapper}
 % \vspace{1cm}
 % \begin{figure}
  %  \centering
   % \includegraphics[scale=0.5]{img/wrapper.jpg}
 % \end{figure}

%\end{frame}


%\begin{frame}[fragile] {Embedded Code}
%    \begin{columns}
%    \begin{column}{.05\textwidth}
%    \end{column}
%    \begin{column}{.4\textwidth}
%  \begin{lstlisting}[language = python]
%class gpsgetter:
%  def helper(loself):
%    ser=Serial('/dev/ttyS0')
%    ser.flushInput()
%    while True:
%      try:
%        bytes = ser.readline()
%        text = bytes.decode("utf-8")
%        if(text.find("GPGGA") >= 0):
%          [...] // working with NMEA
%          time.sleep(30)
%          ser.flushInput()
%       except Exception as ex:
%         [...]
%  \end{lstlisting}
%    \end{column}
%    \begin{column}{.4\textwidth}
%      \begin{lstlisting}[language = python]
%  def start_getter(self):
%    self.actual = gpsdata(0, 0, 0)
%    self.runner = Thread(target=gpsgetter.helper, args=[self])
%    self.runner.start()
%
%  def get_values(self):
%    return self.actual
%
%  def set_values(self, new):
%    self.actual = new
%      \end{lstlisting}
%    \end{column}
%  \end{columns}
%\end{frame}

\begin{frame}{To do until next presentation}

  \begin{itemize}
  \item restrict renting time
  \item improving the security of the private key ( e.g. TrustZone)
  \item improving the handling of the bikeId in the RPI
  \item attack vectors of the application
  \item Code documentation
  \end{itemize}
  
\end{frame}

\begin{frame}

\begin{minipage}{\linewidth}
\centering
%\begin{sideways}

\begin{ganttchart}[
    hgrid style/.style={black, dotted},
    vgrid={*5{black,dotted}, *1{white, dotted}, *1{black, dashed}},
    x unit=1.2mm,
    y unit chart=3mm,
    y unit title=5mm,
    time slot format=isodate,
    group label font=\bfseries ,
    link/.style={->, thick}
    ]{2020-04-27}{2020-07-26}
    \gantttitlecalendar{month=name}\\

    \ganttgroup[
        group/.append style={fill=orange}
    ]{Milestone 1}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US1
    ]{US1}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US2
    ]{US2}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US3
    ]{US3}{2020-04-27}{2020-05-11}\\ [grid]


    \ganttgroup[
        group/.append style={fill=blue}
    ]{Milestone 2}{2020-05-11}{2020-06-22} \\[grid]
    \ganttbluebar{US4}{2020-05-25}{2020-06-08}\\ [grid]
    \ganttbluebar{US5}{2020-06-08}{2020-06-22} \\[grid]
    \ganttbluebar{US6}{2020-05-11}{2020-05-25} \\[grid]

    \ganttgroup[
        group/.append style={fill=green}
    ]{Milestone 3}{2020-05-25}{2020-06-22} \\[grid]
    \ganttgreenbar{US7}{2020-06-08}{2020-06-22}\\ [grid]
    \ganttgreenbar{US8}{2020-05-25}{2020-06-08} \\[grid]
    \ganttgreenbar{US9}{2020-06-08}{2020-06-22} \\[grid]

        \ganttgroup[
        group/.append style={fill=yellow}
    ]{secure Storage}{2020-06-22}{2020-07-12} \\[grid]


    \ganttgroup[
        group/.append style={fill=gray}
    ]{Submissions}{2020-04-27}{2020-07-19} \\[grid]
    \ganttgraybar{Progress Report 1}{2020-05-18}{2020-05-24}\\ [grid]
    \ganttgraybar{Progress Report 2}{2020-06-15}{2020-06-21} \\[grid]
    \ganttgraybar{Final Report}{2020-06-22}{2020-07-19} \\[grid]
    

    

\end{ganttchart}

%\end{sideways}
\end{minipage}

  
\end{frame}


\begin{frame}
  \vspace{3cm}
  \centering
  \textbf{Thanks for listening} \\
  \textbf{Questions?}
\end{frame}

\end{document}

